 ____   __   ____  _  _    ____     ___   __   __    __    ____  ____  _  _
(  __) / _\ / ___)( \/ )  (___ \   / __) / _\ (  )  (  )  (  __)(  _ \( \/ )
 ) _) /    \\___ \ )  /    / __/  ( (_ \/    \/ (_/\/ (_/\ ) _)  )   / )  /
(____)\_/\_/(____/(__/    (____)   \___/\_/\_/\____/\____/(____)(__\_)(__/

***************** 1.4.14-pl ******************
+ bugfixed missing icons because of template changes since MODX 1.0.12
+ bugfixed filemtime conversion to mysql's DATETIME
+ added set/get Error

***************** 1.4.13-pl ******************
+ modified the filename for the cache files to reduce space usage in hosting

***************** 1.4.13-rc1 ******************
+ fixed bug on counting files of directory that has thumbnail specified
+ modified queries

***************** 1.4.12-pl ******************
+ replaced mysql_escape_string to mysql_real_escape_string on comments.easy2gallery.php

***************** 1.4.11-pl ******************
+ fixed bug on language methods
+ replaced mysql_escape_string to mysql_real_escape_string
+ fixed sanitizedGets method

***************** 1.4.10-pl ******************
+ fixed output for empty directory
+ sanitized $_GET inside the snippet's class
+ added utf-8 encoding to the decode function
+ fixed tag separator on the easy2tagcloud
+ added backtick to the database name on mysql function
+ fixed wrong condition's output
+ fixed landingpage's placeholders and typo on comment's method
+ fixed zero counter for directory
+ fixed directory sql error on updating
+ fixed slight error of the web groups output on module

***************** 1.4.10-rc4 ******************
+ fixed the charset output for the ajax's controller files
+ fixed the file permission's converter
+ added German translation (thx to bbear)
+ fixed the translation's trim
+ added PIE-1.0beta5 to the libs/ , and fixed its CSS's directives

***************** 1.4.10-rc3 ******************
+ replaced all $_GET params with sanitizedGets
+ added &w=`auto` or &h=`auto` to keep the original proportion of the thumbnail
+ set the synchronizer to only synching the current opened folder

***************** 1.4.10-rc2 ******************
+ fixed parent id changes on the module pages

***************** 1.4.10-rc1 ******************
Fixes:
+ fixed file delete button
+ fixed sanitizedGets method

***************** 1.4.9 ******************
Fixes:
+ fixed breadcrumbs
+ fixed unsyncronized folder links
+ bugfixed the restricted access to the prev-up-next navigation
+ added the restricted access icon on the module's list
+ debug returned the valid folders as false

Improvements:
+ secured the module class on the GET requests
+ deleted old template files
+ refactored the snippet's class
+ added &wmposxy for specified x,y watermark's position
+ added &folder_w, &folder_h and &folder_thq parameters
  to provide different dimensions to the folder's thumbnail on the runtime
  (snippet call only)
+ added the new easy2tagcloud snippet

***************** 1.4.8 ******************
Fix:
+ #5301 $_SERVER['HTTP_X_FORWARDED_FOR'] faking by modifiying the headers

***************** 1.4.7 ******************
Fixes:
+ Bugfixed the sibling infos for prev up next navigation
+ Updated the slideshow's limit to be able to use the Template Variable
+ Bugfixed the config file checker
+ Bugfixed the language's multibyte string

***************** 1.4.6 ******************
Fixes:
+ Bugfixed the module's javascript on handling bottom menu when the ZipArchive is unavailable

***************** 1.4.5 ******************
Improvement:
+ Added output buffer to the watermarking
+ Changed the blank output of the wild parameter's title and description

Fixes:
+ Bugfixed the wild parameter's joint gid+fid SQL statement
+ Bugfixed the image directive of the galleriffic's example-5

***************** 1.4.4 ******************
Improvement:
+ Reworked how the slideshow's file being included

Fixes:
+ Bugfixed the slideshow image duplication

***************** 1.4.3 ******************
Improvement:
+ Added the character set selection on installation
+ Optimized the image's variables on slideshow
+ Optimized the gallery set of the smoothgallery's slideshow

Fixes:
+ Bugfixed the blank image info from the upload form

***************** 1.4.2 ******************
+ Added the file permission mode options

***************** 1.4.1 ******************
Improvement:
+ Added realpath to all file inclusions and requires

Fixes:
+ Bugfixed invalid path directives inside the js files of the moved library's folders
+ Bugfixed watermark option to the slideshow's image shaper
+ Bugfixed encoding on snippet's image url

********** 1.4.0-Public Release **********
Improvement:
+ Editable the values of the current, previous and next navigation
+ Added the selective thumbnail to the directory
+ Updated the new library folders directive
+ Simplify the buttons and added some icons
+ Updated russian lang files
+ Added auto save config after installation.
+ Ajaxified some pages on the Module side
+ Added options to the siblings navigation
+ Updated the UTF-8 class by Rin

Fixes:
+ the first usergroup selection
+ the duplicate names issues
+ UTF-8 filenaming
+ the get_magic_quote checking

Removes:
- Floatbox: download from http://randomous.com/floatbox/download
  We do not support it anymore.

********** 1.4.0-Release Candidate 4 **********
+ Bug fixing on the chmod permissions
+ Bug fixing on the directory editing
+ Moving around the class methods into separate files.
+ Added French lang files (credit: Marc)
+ Thumbnails on module page
+ Added more options for the thumbnail generator
+ Created a new method to hold the slideshow variables
+ Sliced the snippet's pagination to be shorter
+ Changed the &crumbs_use option values: 'foldername' => 'cat_name' | 'alias' => 'cat_alias'
+ Renamed the file's 'name' field to be 'alias' to distinct the term with filename
+ New parameters :
  + For manual templates:
      + &glib=`0`           : will disable all the gallery's headers loading.
      + &autoload_css=`0`   : will disable the gallery's CSS headers loading.
      + &autoload_js=`0`    : will disable the gallery's JS headers loading.
      + &autoload_html=`0`  : will disable the gallery's HTML block headers loading.
  + &use_redirect_link:
    The thumbnails (directories or images) now can be redirected to a specified link that has been set from inside Module.
    Empty content will make the links fall back to the original E2G's link.
+ Deprecated parameters :
  - &pagenum_class
    Specified the class directly on the template
  - &back_class
    Specified the class directly on the template
+ Fixed issue on the joining parameters (&gid and &fid) in one snippet call.
+ Updated the floatbox to 4.20 version

SOMETHING MAY BREAK ON UPGRADING:
+ Custom Slideshow:
  This version now stores the slideshows parameters inside a method.
  The usage should be changed just like this:
  + To get all the slideshow parameters: $ssParams = $this->_getSlideShowParams();
  + To gel all the slideshow files     : $ssFiles = $this->_getSlideShowFiles();
+ Directory's link:
  since now the E2G's thumbnails can be redirected to a specified link, the template's placeholder has been changed:
  old: <a href="[+easy2:link+][+easy2:cat_id+][+easy2:cat_tag+]#[+easy2:permalink+]">
  new: <a href="[+easy2:link+]">

********** 1.4.0-Release Candidate 3 **********
+ Bug fixings on the converted variables
+ Bug fixings on the chmod permissions
+ Updated simple slideshow

********** 1.4.0-Release Candidate 2 **********
+ Many bug fixings
+ Created individual module's internal pages
+ Added plugin and slideshow managers and databases
+ Enhanced the E2G's internal plugin with the System Event to provide hook
+ Added reCaptcha
+ Added more functions on the file manager
+ Added User management to integrate with MODx's user management
+ Added more comments function
+ Added Dashboard page on the module
+ Added the wild-parameter &gid=`*` (star symbol) to select all directories and images.
+ Added &where_dir and &where_file paramaters as additional SQL's WHERE CLAUSE statements
+ Added Previous/Up/Next Navigation
+ Added 'Follow orientation' configuration on image resizing
+ Added Sizzle as the selector library

REQUIRED REDO ON UPGRADING
+ Slideshows & Plugins:
    - custom coding: All outputs should be 'echo'-ed. Output Buffering will take the rest.
    - snippet call: &ss_allowedratio=`none` now should be &ss_allowedratio=`all`

********** 1.4.0-Release Candidate 1 **********
+ Many bug fixings
+ Folders are restructured
+ Many changes on variable names for new updates
+ Using assets/images/gallery for its default folder of the fresh installation.
  But still use the old path (assets/gallery) if this is an upgrade.

MODULE
+ Added move folders option
+ Download option
+ Added translation page
+ More options in config area

SNIPPET
+ Added &tag parameter
+ Added &plugin for thumbnails, gallery, and landingpage
+ Restrictive descendant of specified gallery's call: restrict the address bar, and crumbs
+ Added permalink to the gallery template
+ &landingpage option is now applied to the original gallery's thumbnail, too

********** 1.4.0-Beta 4 **********
+ UTF 8 Bug Fix
+ Filenaming bug fix
+ Simple slideshow is turned to be independent from the core code.
+ Slideshow Galleriffic (http://www.twospy.com/galleriffic/) was added.
+ Slideshow SmoothGallery (http://smoothgallery.jondesign.net) was added.
+ Slideshow GalleryView (http://spaceforaname.com/galleryview) was added.
+ Slideshow ContentFlow (http://www.jacksasylum.eu/ContentFlow) was added.
+ Added &landingpage parameter, to be used as a single page template of slideshow's hyperlink.
--+ inside the landing page, the snippet call is : [!easy2? &landingpage=`-its own pageID number-`!]
--+ the landingpage template is 'page.htm'
--+ this still can be applied the &css and &js parameter, if it's needed.

Available parameters for the slideshow:

    * &gid
      Gallery ID
    * &fid
      File ID
    * &rgid
      Random file from the specified Gallery ID
    * &slideshow=`galleriffic`
      this is the mandatory call to this slideshow type
    * &ss_config
      Each of slideshow can have different options or types.
      Eg Options in galleriffic slideshow:
          o `example-1`
          o `example-2`
          o `example-3`
          o `example-5`
    * &ss_w : the width of the slideshow box (image size)
      Default: 400px
    * &ss_h : the height of it
      Default: 300px
    * &w : the width of the thumbnail images
      Default: whatever you've set in the module's config
    * &h : the height of it
      Default: whatever you've set in the module's config
    * &ss_bg
      background color of the slideshow, not for the thumbnail
    * &ss_limit
      the SQL limitation when selecting the images. Only applied to gallery ID and random gallery ID.
      Options:
          o integers
          o `none` : you don't make any limit, show all images under the directory.
      Default: (int) 6
    * &ss_indexfile : the index file path of your own slideshow's generator.
    * &ss_css : the CSS path of your own styling, which will override the default styles.
    * &ss_js : the JS path of your own Javascript, which will override the default JS.

Available parameters for your own slideshow:
    * $_ssFile['id'] : image ID.
    * $_ssFile['dirid'] : directory ID.
    * $_ssFile['src'] : image's source path.
    * $_ssFile['filename'] : image filename (basename).
    * $_ssFile['title'] : image's title (if name doesn't exist, it'll use filename).
    * $_ssFile['name'] : image's name (only).
    * $_ssFile['description'] : image's description.
    * $_ssFile['thumbsrc'] : thumbnail's path.
    * $_ssFile['resizedimg'] : resized image's path (resized by restricting width + height of slideshow's box).

********** 1.4.0-Beta 3 **********
+ Fixed small bug in pagination calculation, again...
+ Introducing additional parameters:
--+ &slideshow : simple (more type of slideshow will be added soon)
----+ &ss_w - slideshow width box, default = 400 (in px)
----+ &ss_h - slideshow height box, default = 300 (in px)
----+ &ss_bg - box background color, default = white
----+ &ss_allowedratio - allowed width/height ratio of image dimension inside slideshow box, default 0.75*(&ss_w/&ss_h) - 1.25*(&ss_w/&ss_h).
Options:

    * 'minimumfloatnumber-maximumfloatnumber', eg: `1.0-2.0`
    * 'none' - disable this ratio, all landscape/portrait images will be shown

----+ &ss_limit - limit number of images for the slideshow, default NULL.
More images mean slower page loading.
+ UTF-8
+ Invalid characters checking
+ Numbering on duplication

********** 1.4.0-Beta 2 **********
+ Fixed small bug in pagination calculation

********** 1.4.0-Beta 1 **********
+ Many bug fixing
+ Additional tab inside module: Comments Manager
+ Introducing additional parameters:
--+ &resize_type : inner | shrink | resize
--+ &thbg_red (Red in RGB background color)
--+ &thbg_green (Green in RGB background color)
--+ &thbg_blue (Blue in RGB background color)
+ All textarea now supports TinyMCE
+ Directory database now includes Description.
+ Comment system now has IP Address ignoring
--> when you're ignoring an IP Address, comment hyperlink will be hidden from the specified IP Address
+ Fixed the SQL upgrade code

********** 1.3.6-Beta 3 **********
+ Critical Update on Javascript
+ Now you can have multi IDs, for &fid, &gid, &rgid
+ Introducing some parameters:
--+ &showonly : images | folders
--+ $customgetparams (for nesting with other snippets)
+ Directory & images share same pagination
+ English libraries, except lightwindow (author's site is dead)
+ Broken down Module into classes and templates, will be very useful for further development of any additional PHP functions or Module's interface.
+ See the help page
+ Libraries arguments now have been merged in one file only: includes/config.libs.easy2gallery.php

IMPORTANT UPGRADE step:
you must change your module code as:
include(MODX_BASE_PATH.'assets/modules/easy2/index.php');

********** 1.3.6-Beta 2 **********

MODULE
1. file's/folder's name will not be renamed again
2. the original folder's & file's names restoration in the upgrading installation process
3. each of folders will have index.html (Unautorized Direct Access to folder), each time of directory creation or each time synchro action finds a folder doesn't have index.html.
4. as #3, this time synchro will exclude index.html, index.htm, index.php, Thumbs.db for the database synchronization.
5. editing directory name will also rename the real folder's name.
6. change the default installation language.
7. add output buffering to avoid PHP's memory limit.
8. add natural sort order of gallery's list

SNIPPET
1. Now with PHP classes.
2. Directories and files are now sharing the same Grid and Pagination. The &limit parameter applies as the joined result.
3. Comment with email validation.

LANGUAGE
1. English
2. Russian
3. Spanish ( credit: redstormj (Jose R. Lopez) )
4. Dutch ( credit: DNA )